/*******************************************************************************
 * Copyright (c) 2005, 2007 committers of openArchitectureWare and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Clemens Kadura (zAJKa) - Initial API and implementation
 *******************************************************************************/
package org.openarchitectureware.debug.processing.handlers;

import static org.openarchitectureware.debug.processing.handlers.BreakpointRuntimeHandler.REMOVE;
import static org.openarchitectureware.debug.processing.handlers.BreakpointRuntimeHandler.SET;

import java.io.IOException;

import org.openarchitectureware.debug.communication.Connection;
import org.openarchitectureware.debug.communication.packets.BreakpointPacket;
import org.openarchitectureware.debug.model.OawBreakpoint;
import org.openarchitectureware.debug.processing.DebugModelManager;
import org.openarchitectureware.debug.processing.IPluginHandler;

/**
 * This class handles the communication of breakpoints on the Eclipse side
 */
public class BreakpointPluginHandler implements IPluginHandler {

	private Connection connection;

	// -------------------------------------------------------------------------

	public void setConnection(Connection connection) {
		this.connection = connection;
	}

	public void setDebugModelManager(DebugModelManager dmm) {
		// don't need it
	}
	
	// -------------------------------------------------------------------------

	public void sendSetBreakpoint(OawBreakpoint bp) throws IOException {
		connection.sendPacket(new BreakpointPacket(SET, bp.createTO()));
	}

	public void sendRemoveBreakpoint(OawBreakpoint bp) throws IOException {
		connection.sendPacket(new BreakpointPacket(REMOVE, bp.createTO()));
	}

}
