/*******************************************************************************
 * Copyright (c) 2005, 2006 committers of openArchitectureWare and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare - initial API and implementation
 *******************************************************************************/
package org.openarchitectureware.workflow.lib;

import org.openarchitectureware.workflow.WorkflowContext;
import org.openarchitectureware.workflow.issues.Issues;
import org.openarchitectureware.workflow.monitor.ProgressMonitor;

public abstract class SimpleJavaModificationComponent extends WorkflowComponentWithModelSlot {

	private Object modelObject;

	public void invoke(final WorkflowContext ctx, final ProgressMonitor monitor, final Issues issues) {
		modelObject = ctx.get(getModelSlot());
		if (modelObject == null) {
			issues.addWarning(this, "content of modelSlot " + getModelSlot() + " is null.");
		}
		doModification(ctx, monitor, issues, modelObject);
	}

	protected abstract void doModification(WorkflowContext ctx, ProgressMonitor monitor, Issues issues, Object model);

}
