/*******************************************************************************
 * Copyright (c) 2005 - 2008 committers of openArchitectureWare and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare - initial API and implementation
 *******************************************************************************/
package org.openarchitectureware.xsd;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.mwe.emf.AbstractEmfWorkflowComponent;
import org.openarchitectureware.type.MetaModel;
import org.openarchitectureware.workflow.issues.Issues;

/**
 * @author Moritz Eysholdt
 */
public abstract class AbstractXMLWorkflowComponent extends
		AbstractEmfWorkflowComponent {

	private List<MetaModel> allMetaModels = new ArrayList<MetaModel>();

	private XSDMetaModel xsdMetaModel;

	public void addMetaModel(MetaModel metaModel) {
		if (metaModel instanceof XSDMetaModel)
			this.xsdMetaModel = (XSDMetaModel) metaModel;
		this.allMetaModels.add(metaModel);
	}

	public void checkConfiguration(Issues issues) {
		if (xsdMetaModel == null)
			issues.addError(this, "An XSDMetaModel needs to be specified");
		super.checkConfiguration(issues);
	}

	public List<MetaModel> getAllMetaModels() {
		return allMetaModels;
	}

	public XSDMetaModel getMetaModel() {
		return xsdMetaModel;
	}
}
