/*******************************************************************************
 * Copyright (c) 2005 - 2008 committers of openArchitectureWare and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare - initial API and implementation
 *******************************************************************************/
package org.openarchitectureware.xsd.util;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * @author Moritz Eysholdt
 */
public class XSDLog {

	public static interface XSDLogFactory {
		public Log getLog(Class<?> clazz);
	}

	private static XSDLogFactory factory = new XSDLogFactory() {
		public Log getLog(Class<?> clazz) {
			return LogFactory.getLog(clazz);
		}
	};

	public static Log getLog(Class<?> clazz) {
		return factory.getLog(clazz);
	}

	public static void setLogFactory(XSDLogFactory fac) {
		factory = fac;
	}

}
