/*
 * <copyright>
 *
 * Copyright (c) 2005-2006 Sven Efftinge and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Sven Efftinge - Initial API and implementation
 *
 * </copyright>
 */

package org.openarchitectureware.xtend.editor;

import org.openarchitectureware.editor.AbstractOawEditor;
import org.openarchitectureware.editor.outlineview.AbstractOawContentOutlinePage;
import org.openarchitectureware.xtend.editor.outline.XtendContentOutlinePage;

public class XtendEditor extends AbstractOawEditor {

	public XtendEditor() {
		setSourceViewerConfiguration(new XtendSourceViewerConfiguration(this));
		setDocumentProvider(new XtendDocumentProvider());
	}

	@Override
	protected AbstractOawContentOutlinePage createOutlinePage() {
		registerDocumentListener();
		return new XtendContentOutlinePage(this);
	}

	@Override
	protected void initializeKeyBindingScopes() {
		setKeyBindingScopes(new String[] { "org.openarchitectureware.xtend.editor.XtendEditorScope" }); //$NON-NLS-1$
	}
}
