/*******************************************************************************
 * Copyright (c) 2007 Sven Efftinge (http://www.efftinge.de) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare
 *******************************************************************************/
package org.openarchitectureware.xtext;

import org.eclipse.jface.dialogs.IDialogSettings;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.plugin.AbstractUIPlugin;

public class BaseEditorPlugin extends AbstractUIPlugin {
    // The shared instance.
    private static BaseEditorPlugin plugin;

    public static final String PLUGIN_ID = "org.openarchitectureware.xtext.editor.base";
    /**
     * The constructor.
     */
    public BaseEditorPlugin() {
        plugin = this;
    }

    /**
     * Returns the shared instance.
     */
    public static BaseEditorPlugin getDefault() {
        return plugin;
    }

    public static ImageDescriptor getImageDescriptorFromBase(String path) {
		return AbstractUIPlugin.imageDescriptorFromPlugin(getDefault().getBundle().getSymbolicName(), path);
	}
    
    public IDialogSettings getDialogSettingsSection(String name) {
		IDialogSettings dialogSettings= getDialogSettings();
		IDialogSettings section= dialogSettings.getSection(name);
		if (section == null) {
			section= dialogSettings.addNewSection(name);
		}
		return section;
	}
}
