/*******************************************************************************
 * Copyright (c) 2007 Sven Efftinge (http://www.efftinge.de) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare
 *******************************************************************************/
 package org.openarchitectureware.xtext.editor.scanning;

import org.eclipse.jface.text.rules.IRule;
import org.eclipse.jface.text.rules.WhitespaceRule;
import org.openarchitectureware.xtext.AbstractXtextEditorPlugin;

/**
 * @author Sven Efftinge (http://www.efftinge.de)
 * 
 * 
 */
public class StringScanner extends AbstractRuleBasedScanner {

    public StringScanner(AbstractXtextEditorPlugin plugin) {
        super(plugin);
        IRule[] rules = new IRule[1];
        // Add generic whitespace rule.
        rules[0] = new WhitespaceRule(new WhitespaceDetector());

        setRules(rules);
        setDefaultReturnToken(string);
    }
}